--- u-boot-2011.06_original/board/cavium/cnc1900/cnc1900.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/board/cavium/cnc1900/cnc1900.c	2015-09-25 11:55:28.920111000 +0800
@@ -0,0 +1,292 @@
+/*
+ * (C) Copyright 2012
+ * Cavium Networks xiaodong.fan@cavium.com
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+#include <netdev.h>
+#include <asm/io.h>
+#include <div64.h>
+#include <spi_flash.h>
+#include "irqs.h"
+
+DECLARE_GLOBAL_DATA_PTR;
+
+#define PINMUX_I2C_ENABLE 0xb2110004
+#define PINMUX_UART_ENABLE 0xb2110008
+#define PINMUX_SPI_ENABLE 0xb211000c
+#define PINMUX_SMI_ENABLE 0xb2110010
+#define PINMUX_DISPLAY_ENABLE 0xb2110014
+#define PINMUX_ETHER_ENABLE 0xb2110020
+
+#define TEST_IRQ
+
+#define HW_REG_READ( ByteAddr )      (*(volatile unsigned int*)(ByteAddr))
+
+#ifndef CONFIG_SF_DEFAULT_SPEED
+# define CONFIG_SF_DEFAULT_SPEED	1000000
+#endif
+#ifndef CONFIG_SF_DEFAULT_MODE
+# define CONFIG_SF_DEFAULT_MODE		SPI_MODE_3
+#endif
+
+
+#ifdef CONFIG_USE_IRQ
+irq_handle cnc1900_irq_vector[NR_IRQS];
+void * cnc1900_irq_data[NR_IRQS];
+
+extern int gpio_hw_set_direct(int gpio_id, int dir);
+extern int gpio_hw_write(int gpio_id, unsigned short data);
+
+void cnc1900_irq_enable(unsigned int irq)
+{
+    if (irq>=0 && irq< NR_IRQS)
+        *(((unsigned int*)(GIC_DIST_BASE+0x100 + (irq / 32) * 4))) = 1 << (irq % 32);
+}
+
+void cnc1900_irq_disable(unsigned int irq)
+{
+    if (irq>=0 && irq< NR_IRQS)
+        *(((unsigned int*)(GIC_DIST_BASE + 0x180 + (irq / 32) * 4))) = 1 << (irq % 32);
+}
+
+void cnc1900_register_irq(int irq, irq_handle irq_r, void * irq_data)
+{
+    if (irq>=0 && irq< NR_IRQS) {
+        cnc1900_irq_vector[irq] = irq_r;
+        cnc1900_irq_data[irq] = irq_data;
+    }
+}
+
+void cnc1900_unregister_irq(int irq)
+{
+    if (irq>=0 && irq< NR_IRQS) {
+        cnc1900_irq_vector[irq] = NULL;
+        cnc1900_irq_data[irq] = NULL;
+    }
+}
+
+#ifdef TEST_IRQ
+/*for test only*/
+extern int gpio_num_for_blink;
+int blink_toggle = 1;
+int wd_timer_irq_handle(unsigned int irq, void * data)
+{
+	//printf("in wd_timer_irq_handle \n");
+	blink_toggle = !blink_toggle;
+	if(-1 != gpio_num_for_blink){
+		gpio_hw_set_direct(gpio_num_for_blink, 1);
+		gpio_hw_write(gpio_num_for_blink, blink_toggle);
+	}
+	return 0;
+ }
+
+void disable_and_unregister_wd_timer_irq(void)
+{
+	 cnc1900_irq_disable(30);
+        cnc1900_unregister_irq(30);
+}
+
+void register_and_enable_wd_timer_irq(unsigned int ticks)
+{
+	printf("ticks = %d\n", ticks);
+    //write WD Timer Interrupt Status Register
+    //clear the possible unwanted interrupt request before enable WD timer interrupt
+    (*( (volatile unsigned int*)(CNC1900_CA9_TWD+0x2C) )) = 1;
+
+    //write WD Timer Load Register, delay time
+    (*( (volatile unsigned int*)(CNC1900_CA9_TWD+0x20) )) = ticks;
+
+    //write WD Timer Control Register
+    //WD mode = 0
+    //IRQ enable = 1
+    //Auto reload = 1
+    //WD enable = 1
+    (*( (volatile unsigned int*)(CNC1900_CA9_TWD+0x28) )) = 7;   
+
+    cnc1900_register_irq(30, wd_timer_irq_handle, (void *) NULL);
+    cnc1900_irq_enable(30);
+}
+
+#endif
+
+int arch_interrupt_init(void)
+{
+    int i;
+
+    for (i=0; i< NR_IRQS; i++) {
+        cnc1900_irq_vector[i] = NULL;
+        cnc1900_irq_data[i] = NULL;
+    }
+
+    //set Vector Base Address Register to 0.
+    __asm__ __volatile__(
+        "mov r0, #0                                  @prepare data \n\t"
+        "mcr p15, 0, r0, c12, c0, 0                  @Write CP15 Vector Base Address Register \n\t"
+        :::"r0");
+
+    //set all shareable peripheral interrupts as secure interrupt
+    for(i=0;i<3;i++)
+    {
+        *(((unsigned int*)(GIC_DIST_BASE+0x80))+i)=0;
+    }
+
+    //set all shareable peripheral interrupts as level sensitive, high active
+    for(i=0;i<4;i++)
+    {
+        *(((unsigned int*)(GIC_DIST_BASE+0xc00+0x8))+i)=0x55555555;
+    }
+
+    //set the priority of all shareable peripheral interrupts to 0(the highest priority)
+    for(i=0;i<24;i++)
+    {
+        *(((unsigned int*)(GIC_DIST_BASE+0x400))+i)=0;
+    }
+
+    //set all PPI and SPI target to all CPU interface
+    for(i=0;i<24;i++)
+    {
+        *(((unsigned int*)(GIC_DIST_BASE+0x800))+i)=0x11111111;
+    }
+
+    //disable all interrupts
+    for(i=0;i<3;i++)
+    {
+        *(((unsigned int*)(GIC_DIST_BASE+0x180))+i)=0xFFFFFFFF;
+    }
+
+    //set the priority mask of cpu interface to 8'hff(the lowest priority)
+    *(((unsigned int*)(GIC_CPU_BASE+0x4)))=0xf0;
+    
+    //set the binary point position of cpu interface to 8'hff(not grouping interrupt)
+    *(((unsigned int*)(GIC_CPU_BASE+0x8)))=0xff;
+
+    //enable all interrupts in CPU interface
+    //set all interrupts are sent to CPU through IRQ pin
+    *(((unsigned int*)(GIC_CPU_BASE+0x0)))=0x3;
+
+    //enable all interrupts in interrupt distributor
+    *(((unsigned int*)(GIC_DIST_BASE+0x0)))=0x1;
+
+    //disable low interrupt latency
+    __asm__ __volatile__(
+        "mrc p15, 0, r0, c1, c0, 0   @read CP15 system control register \n\t"
+        "and r0, r0, #0xffdfffff     @clear FI bit to 0 \n\t"
+        "mcr p15, 0, r0, c1, c0, 0   @write CP15 system control register \n\t"
+        :::"r0");
+
+    //setup_wd_timer_irq(300000000);
+    return 0;
+}
+
+int cnc1900_do_interrupt(void)
+{
+    int vec;
+    //read interrupt ID and acknowlege this interrupt.
+    vec = (*( (volatile unsigned int*)(GIC_CPU_BASE+0xC)));
+
+    if(vec<NR_IRQS)
+    {
+        if (NULL != cnc1900_irq_vector[vec]) 
+        {
+            cnc1900_irq_vector[vec](vec,cnc1900_irq_data[vec]);
+        }
+    }
+
+    //end this interrupt.
+    (*( (volatile unsigned int*)(GIC_CPU_BASE+0x10)))=vec;
+
+    return 0;
+}
+#endif
+/*
+ * Miscellaneous platform dependent initialisations
+ */
+
+const unsigned int pll_cpu_div_qv[4] = {1, 2, 4, 6};
+int board_init(void)
+{
+	unsigned int pll_cpu_div_f, pll_cpu_div_q;
+	unsigned int pll_ddr_div_f, pll_ddr_div_q;
+	unsigned long long big = (2LL << 32) * 27000000, div;
+
+    gd->bd->bi_arch_number = 1662;
+    gd->bd->bi_boot_params = 0x00000100;
+    icache_enable();
+
+#ifdef CONFIG_SPI_FLASH_CNC1900 
+	spi__init();
+#endif
+
+	pll_cpu_div_f = (HW_REG_READ(0xb2100318) >> 6) & 0x7f;
+	pll_cpu_div_q = (HW_REG_READ(0xb2100318) >> 3) & 0x7;
+
+	pll_ddr_div_f = (HW_REG_READ(0xb2100338)) & 0x3fffffff;
+	pll_ddr_div_q = (HW_REG_READ(0xb2100334)) & 0x1f;
+
+	div = (unsigned long long)pll_ddr_div_f * (2 * pll_ddr_div_q + 2);
+	gd->ddr_freq = lldiv(big, div) * 2;
+	gd->cpu_freq = (unsigned int)lldiv((unsigned long long)(pll_cpu_div_f + 1) * 54000000LL, pll_cpu_div_qv[pll_cpu_div_q]);
+#if 0
+	printf("CPU / DDR: %dMHz / %dMHz\n", gd->cpu_freq / 1000000, gd->ddr_freq / 1000000);
+#endif
+	
+
+    return 0;
+}
+
+int board_late_init(void)
+{
+	unsigned int miniloader_signature;
+	char *current_env = getenv("uboot_image");
+	char *new_env;
+
+#ifndef CONFIG_SPI_FLASH_CNC1900 
+	spi_flash_probe(0, 0, CONFIG_SF_DEFAULT_SPEED, CONFIG_SF_DEFAULT_MODE);
+#endif
+
+
+	miniloader_signature = *((volatile unsigned int *)(0x7000000));
+	if((miniloader_signature & 0xffff0000) == 0xdead0000){
+		new_env = (miniloader_signature & 1)?"2":"1";
+		/* Save new env only if it is different from the current one */
+		if(current_env == NULL || *current_env != *new_env){
+			setenv("uboot_image", new_env);
+			saveenv();
+		}
+	}
+	return 0;
+}
+
+int dram_init(void)
+{
+	gd->ram_size = get_ram_size(CONFIG_SYS_SDRAM_BASE,
+				    CONFIG_SYS_SDRAM_SIZE);
+	return 0;
+}
+
+void dram_init_banksize(void)
+{
+	gd->bd->bi_dram[0].start = PHYS_SDRAM_1;
+	gd->bd->bi_dram[0].size = PHYS_SDRAM_1_SIZE;
+}
+
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/board/cavium/cnc1900/irqs.h u-boot-2011.06/board/cavium/cnc1900/irqs.h
--- u-boot-2011.06_original/board/cavium/cnc1900/irqs.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/board/cavium/cnc1900/irqs.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,174 @@
+#ifndef __ORION_IRQS_H__
+#define __ORION_IRQS_H__
+
+
+typedef int (* irq_handle)(unsigned int, void *);
+
+
+#define GIC_CPU_BASE           (0x80020000+0x100)
+#define CNC1900_CA9_TWD        (0x80020000+0x600)
+#define GIC_DIST_BASE          (0x80020000+0x1000)
+
+
+
+
+#define PA_VIC_BASE		    0x80140000
+#define VIC_IRQ_STATUS	0x28	/*mask status*/
+#define VIC_IRQ_ENABLE	0
+#define VIC_IRQ_MASK	8	
+
+#define INT_VICSOURCE21                 21      
+#define INT_VICSOURCE22                 22     
+#define INT_VICSOURCE23                 23     
+#define INT_VICSOURCE24                 24      
+#define INT_VICSOURCE25                 25    
+#define INT_VICSOURCE26                 26      
+#define INT_VICSOURCE27                 27      
+#define INT_VICSOURCE28                 28      
+#define INT_VICSOURCE29                 29        /* Ethernet */
+#define INT_VICSOURCE30                 30      
+#define INT_VICSOURCE31                 31    
+
+
+#define IRQ_VIC_START		0
+#define IRQ_WDOGINT		(IRQ_VIC_START + INT_WDOGINT)
+#define IRQ_SOFTINT		(IRQ_VIC_START + INT_SOFTINT)
+#define IRQ_COMMRx		(IRQ_VIC_START + INT_COMMRx)
+#define IRQ_COMMTx		(IRQ_VIC_START + INT_COMMTx)
+#define IRQ_TIMERINT0_1		(IRQ_VIC_START + INT_TIMERINT0_1)
+#define IRQ_TIMERINT2_3		(IRQ_VIC_START + INT_TIMERINT2_3)
+#define IRQ_GPIOINT0		(IRQ_VIC_START + INT_GPIOINT0)
+#define IRQ_GPIOINT1		(IRQ_VIC_START + INT_GPIOINT1)
+#define IRQ_GPIOINT2		(IRQ_VIC_START + INT_GPIOINT2)
+#define IRQ_GPIOINT3		(IRQ_VIC_START + INT_GPIOINT3)
+#define IRQ_RTCINT		(IRQ_VIC_START + INT_RTCINT)
+#define IRQ_SSPINT		(IRQ_VIC_START + INT_SSPINT)
+#define IRQ_UARTINT0		(IRQ_VIC_START + INT_UARTINT0)
+#define IRQ_UARTINT1		(IRQ_VIC_START + INT_UARTINT1)
+#define IRQ_UARTINT2		(IRQ_VIC_START + INT_UARTINT2)
+#define IRQ_SCIINT		(IRQ_VIC_START + INT_SCIINT)
+#define IRQ_CLCDINT		(IRQ_VIC_START + INT_CLCDINT)
+#define IRQ_DMAINT		(IRQ_VIC_START + INT_DMAINT)
+#define IRQ_PWRFAILINT 		(IRQ_VIC_START + INT_PWRFAILINT)
+#define IRQ_MBXINT		(IRQ_VIC_START + INT_MBXINT)
+#define IRQ_GNDINT		(IRQ_VIC_START + INT_GNDINT)
+#define IRQ_VICSOURCE21		(IRQ_VIC_START + INT_VICSOURCE21)
+#define IRQ_VICSOURCE22		(IRQ_VIC_START + INT_VICSOURCE22)
+#define IRQ_VICSOURCE23		(IRQ_VIC_START + INT_VICSOURCE23)
+#define IRQ_VICSOURCE24		(IRQ_VIC_START + INT_VICSOURCE24)
+#define IRQ_VICSOURCE25		(IRQ_VIC_START + INT_VICSOURCE25)
+#define IRQ_VICSOURCE26		(IRQ_VIC_START + INT_VICSOURCE26)
+#define IRQ_VICSOURCE27		(IRQ_VIC_START + INT_VICSOURCE27)
+#define IRQ_VICSOURCE28		(IRQ_VIC_START + INT_VICSOURCE28)
+#define IRQ_VICSOURCE29		(IRQ_VIC_START + INT_VICSOURCE29)
+#define IRQ_VICSOURCE30		(IRQ_VIC_START + INT_VICSOURCE30)
+#define IRQ_VICSOURCE31		(IRQ_VIC_START + INT_VICSOURCE31)
+#define IRQ_VIC_END		    (IRQ_VIC_START + 31)
+
+#define IRQMASK_WDOGINT		INTMASK_WDOGINT
+#define IRQMASK_SOFTINT		INTMASK_SOFTINT
+#define IRQMASK_COMMRx 		INTMASK_COMMRx
+#define IRQMASK_COMMTx 		INTMASK_COMMTx
+#define IRQMASK_TIMERINT0_1	INTMASK_TIMERINT0_1
+#define IRQMASK_TIMERINT2_3	INTMASK_TIMERINT2_3
+#define IRQMASK_GPIOINT0	INTMASK_GPIOINT0
+#define IRQMASK_GPIOINT1	INTMASK_GPIOINT1
+#define IRQMASK_GPIOINT2	INTMASK_GPIOINT2
+#define IRQMASK_GPIOINT3	INTMASK_GPIOINT3
+#define IRQMASK_RTCINT 		INTMASK_RTCINT
+#define IRQMASK_SSPINT 		INTMASK_SSPINT
+#define IRQMASK_UARTINT0	INTMASK_UARTINT0
+#define IRQMASK_UARTINT1	INTMASK_UARTINT1
+#define IRQMASK_UARTINT2	INTMASK_UARTINT2
+#define IRQMASK_SCIINT 		INTMASK_SCIINT
+#define IRQMASK_CLCDINT		INTMASK_CLCDINT
+#define IRQMASK_DMAINT 		INTMASK_DMAINT
+#define IRQMASK_PWRFAILINT	INTMASK_PWRFAILINT
+#define IRQMASK_MBXINT 		INTMASK_MBXINT
+#define IRQMASK_GNDINT 		INTMASK_GNDINT
+#define IRQMASK_VICSOURCE21	INTMASK_VICSOURCE21
+#define IRQMASK_VICSOURCE22	INTMASK_VICSOURCE22
+#define IRQMASK_VICSOURCE23	INTMASK_VICSOURCE23
+#define IRQMASK_VICSOURCE24	INTMASK_VICSOURCE24
+#define IRQMASK_VICSOURCE25	INTMASK_VICSOURCE25
+#define IRQMASK_VICSOURCE26	INTMASK_VICSOURCE26
+#define IRQMASK_VICSOURCE27	INTMASK_VICSOURCE27
+#define IRQMASK_VICSOURCE28	INTMASK_VICSOURCE28
+#define IRQMASK_VICSOURCE29	INTMASK_VICSOURCE29
+#define IRQMASK_VICSOURCE30	INTMASK_VICSOURCE30
+#define IRQMASK_VICSOURCE31	INTMASK_VICSOURCE31
+
+/* 
+ *  FIQ interrupts definitions are the same the INT definitions.
+ */
+#define FIQ_WDOGINT		INT_WDOGINT
+#define FIQ_SOFTINT		INT_SOFTINT
+#define FIQ_COMMRx		INT_COMMRx
+#define FIQ_COMMTx		INT_COMMTx
+#define FIQ_TIMERINT0_1		INT_TIMERINT0_1
+#define FIQ_TIMERINT2_3		INT_TIMERINT2_3
+#define FIQ_GPIOINT0		INT_GPIOINT0
+#define FIQ_GPIOINT1		INT_GPIOINT1
+#define FIQ_GPIOINT2		INT_GPIOINT2
+#define FIQ_GPIOINT3		INT_GPIOINT3
+#define FIQ_RTCINT		INT_RTCINT
+#define FIQ_SSPINT		INT_SSPINT
+#define FIQ_UARTINT0		INT_UARTINT0
+#define FIQ_UARTINT1		INT_UARTINT1
+#define FIQ_UARTINT2		INT_UARTINT2
+#define FIQ_SCIINT		INT_SCIINT
+#define FIQ_CLCDINT		INT_CLCDINT
+#define FIQ_DMAINT		INT_DMAINT
+#define FIQ_PWRFAILINT 		INT_PWRFAILINT
+#define FIQ_MBXINT		INT_MBXINT
+#define FIQ_GNDINT		INT_GNDINT
+#define FIQ_VICSOURCE21		INT_VICSOURCE21
+#define FIQ_VICSOURCE22		INT_VICSOURCE22
+#define FIQ_VICSOURCE23		INT_VICSOURCE23
+#define FIQ_VICSOURCE24		INT_VICSOURCE24
+#define FIQ_VICSOURCE25		INT_VICSOURCE25
+#define FIQ_VICSOURCE26		INT_VICSOURCE26
+#define FIQ_VICSOURCE27		INT_VICSOURCE27
+#define FIQ_VICSOURCE28		INT_VICSOURCE28
+#define FIQ_VICSOURCE29		INT_VICSOURCE29
+#define FIQ_VICSOURCE30		INT_VICSOURCE30
+#define FIQ_VICSOURCE31		INT_VICSOURCE31
+
+
+#define FIQMASK_WDOGINT		INTMASK_WDOGINT
+#define FIQMASK_SOFTINT		INTMASK_SOFTINT
+#define FIQMASK_COMMRx 		INTMASK_COMMRx
+#define FIQMASK_COMMTx 		INTMASK_COMMTx
+#define FIQMASK_TIMERINT0_1	INTMASK_TIMERINT0_1
+#define FIQMASK_TIMERINT2_3	INTMASK_TIMERINT2_3
+#define FIQMASK_GPIOINT0	INTMASK_GPIOINT0
+#define FIQMASK_GPIOINT1	INTMASK_GPIOINT1
+#define FIQMASK_GPIOINT2	INTMASK_GPIOINT2
+#define FIQMASK_GPIOINT3	INTMASK_GPIOINT3
+#define FIQMASK_RTCINT 		INTMASK_RTCINT
+#define FIQMASK_SSPINT 		INTMASK_SSPINT
+#define FIQMASK_UARTINT0	INTMASK_UARTINT0
+#define FIQMASK_UARTINT1	INTMASK_UARTINT1
+#define FIQMASK_UARTINT2	INTMASK_UARTINT2
+#define FIQMASK_SCIINT 		INTMASK_SCIINT
+#define FIQMASK_CLCDINT		INTMASK_CLCDINT
+#define FIQMASK_DMAINT 		INTMASK_DMAINT
+#define FIQMASK_PWRFAILINT	INTMASK_PWRFAILINT
+#define FIQMASK_MBXINT 		INTMASK_MBXINT
+#define FIQMASK_GNDINT 		INTMASK_GNDINT
+#define FIQMASK_VICSOURCE21	INTMASK_VICSOURCE21
+#define FIQMASK_VICSOURCE22	INTMASK_VICSOURCE22
+#define FIQMASK_VICSOURCE23	INTMASK_VICSOURCE23
+#define FIQMASK_VICSOURCE24	INTMASK_VICSOURCE24
+#define FIQMASK_VICSOURCE25	INTMASK_VICSOURCE25
+#define FIQMASK_VICSOURCE26	INTMASK_VICSOURCE26
+#define FIQMASK_VICSOURCE27	INTMASK_VICSOURCE27
+#define FIQMASK_VICSOURCE28	INTMASK_VICSOURCE28
+#define FIQMASK_VICSOURCE29	INTMASK_VICSOURCE29
+#define FIQMASK_VICSOURCE30	INTMASK_VICSOURCE30
+#define FIQMASK_VICSOURCE31	INTMASK_VICSOURCE31
+
+#define NR_IRQS			96
+
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/board/cavium/cnc1900/lowlevel_init.S u-boot-2011.06/board/cavium/cnc1900/lowlevel_init.S
--- u-boot-2011.06_original/board/cavium/cnc1900/lowlevel_init.S	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/board/cavium/cnc1900/lowlevel_init.S	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,110 @@
+/*
+ * Board specific setup info
+ *
+ * xiaodong fan, <xiaodong.fan@caviumnetworks.com>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <config.h>
+#include <version.h>
+
+        
+/* Set up the platform, once the cpu has been initialized */
+.globl lowlevel_init
+lowlevel_init:
+	mov  pc, lr
+
+
+.globl invalidate_dcache
+invalidate_dcache:
+	stmdb	r13!,{r0,r1,r2,r3,r14}
+	@invalidate instruction cache
+    
+    mov	r1, #0
+    mcr p15, 0, r1, c7, c1, 0
+
+    mcr	p15, 0, r1, c7, c5, 0
+
+	@ invalidate the i&d tlb entries
+	mcr	p15, 0, r1, c8, c5, 0
+	mcr	p15, 0, r1, c8, c6, 0
+
+	@ Now flush the Dcache
+	mov	r0, #0
+	@ 256 cache lines
+	mov	r1, #256
+
+invalidate_loop:
+	add	r1, r1, #-1
+	mov	r0, r1, lsl #5
+	@ invalidate d-cache using line (way0)
+	mcr	p15, 0, r0, c7, c6, 2
+
+	orr	r2, r0, #(1<<30)
+	@ invalidate d-cache using line (way1)
+	mcr	p15, 0, r2, c7, c6, 2
+
+	orr	r2, r0, #(2<<30)
+	@ invalidate d-cache using line (way2)
+	mcr	p15, 0, r2, c7, c6, 2
+
+	orr	r2, r0, #(3<<30)
+	@ invalidate d-cache using line (way3)
+	mcr	p15, 0, r2, c7, c6, 2
+	cmp	r1, #0
+	bne	invalidate_loop
+    mov r1, #0
+    mcr	p15, 0, r1, c7, c10, 4	@ DSB
+    mcr	p15, 0, r1, c7, c5, 4	@ ISB
+      
+	@ FIXME: should have 1900's L2 disabled too?
+    /*invalidate TLB */
+    mov r1, #0x0   
+    mcr p15, 0, r1, c8, c3, 0 
+    mcr	p15, 0, r1, c7, c10, 4	@ DSB
+    mcr	p15, 0, r1, c7, c5, 4	@ ISB
+  
+    /*invalidate branch predictor */
+    mov r1, #0x0
+    mcr p15, 0, r1, c7, c1, 6   
+    mcr	p15, 0, r1, c7, c10, 4	@ DSB
+    mcr	p15, 0, r1, c7, c5, 4	@ ISB
+invalidate_done:
+    ldmia	r13!,{r0,r1,r2,r3,pc}
+
+
+ 
+//void flush_and_then_invalidate_L1_data_cache(unsigned char* p, unsigned int size);
+
+        
+.globl flush_and_then_invalidate_L1_data_cache
+flush_and_then_invalidate_L1_data_cache:     /*function definition*/
+    add r2, r0, r1
+    and r0, r0, #0xffffffe0     /* align the MVA to cache line boundary */
+flush_and_then_invalidate_L1_data_cache_loop:   
+    cmp r0, r2
+    bhi end_flush_and_then_invalidate_L1_data_cache_loop
+    mcr p15, 0, r0, c7, c14, 1  /*issue the command of clean & invalidate data cache line by MVA to point of coherency*/
+    add r0, r0, #0x10           /*move to next cache line*/
+    b flush_and_then_invalidate_L1_data_cache_loop
+end_flush_and_then_invalidate_L1_data_cache_loop: 
+    mcr	p15, 0, r1, c7, c10, 4	@ DSB
+    mcr	p15, 0, r1, c7, c5, 4	@ ISB
+    bx lr
diff '--exclude=.svn' -Naur u-boot-2011.06_original/board/cavium/cnc1900/Makefile u-boot-2011.06/board/cavium/cnc1900/Makefile
--- u-boot-2011.06_original/board/cavium/cnc1900/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/board/cavium/cnc1900/Makefile	2015-05-29 15:18:31.577595000 +0800
@@ -0,0 +1,55 @@
+#
+# (C) Copyright 2000-2004
+# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+#
+# (C) Copyright 2004
+# ARM Ltd.
+# Philippe Robin, <philippe.robin@arm.com>
+#
+# See file CREDITS for list of people who contributed to this
+# project.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+# MA 02111-1307 USA
+#
+
+include $(TOPDIR)/config.mk
+
+LIB	= $(obj)lib$(BOARD).o
+
+COBJS	:= cnc1900.o power_clock.o
+SOBJS	:= lowlevel_init.o
+
+SRCS	:= $(SOBJS:.o=.S) $(COBJS:.o=.c)
+OBJS	:= $(addprefix $(obj),$(COBJS))
+SOBJS	:= $(addprefix $(obj),$(SOBJS))
+
+$(LIB): $(obj).depend $(OBJS) $(SOBJS)
+	$(call cmd_link_o_target, $(OBJS) $(SOBJS))
+
+clean:
+	rm -f $(SOBJS) $(OBJS)
+
+distclean:	clean
+	rm -f $(LIB) core *.bak $(obj).depend
+
+#########################################################################
+
+# defines $(obj).depend target
+include $(SRCTREE)/rules.mk
+
+sinclude $(obj).depend
+
+#########################################################################
diff '--exclude=.svn' -Naur u-boot-2011.06_original/board/cavium/cnc1900/power_clock.c u-boot-2011.06/board/cavium/cnc1900/power_clock.c
